﻿@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using System.Web.UI.WebControls;
@using SPEX.Models;

@Html.DevExpress().GridView(
    settings =>
    {
        settings.Name = "GridServicePriceMaster";
        settings.KeyFieldName = "SERVICE_REGISTRATION";
        settings.CallbackRouteValues = new { Controller = "ServiceMappingMaster", Action = "GetServicePriceMasterCallBack" };
        settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
        settings.ControlStyle.Paddings.Padding = System.Web.UI.WebControls.Unit.Pixel(0);
        settings.ControlStyle.Border.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(0);
        settings.ControlStyle.BorderBottom.BorderWidth = System.Web.UI.WebControls.Unit.Pixel(1);

        settings.ClientSideEvents.BeginCallback = "GridServicePriceMasterOnBeginCallback";
        settings.ClientSideEvents.EndCallback = "GridServicePriceMasterOnEndCallback";

        settings.CommandColumn.Visible = true;
        settings.CommandColumn.ShowSelectCheckbox = true;
        settings.CommandColumn.Width = System.Web.UI.WebControls.Unit.Pixel(40);
        settings.ClientSideEvents.SelectionChanged = "GridServicePriceMaster_SelectionChanged";

        settings.SettingsEditing.Mode = GridViewEditingMode.Inline;

        settings.SettingsPager.Visible = true;
        settings.Settings.ShowFilterRowMenu = false;
        settings.Settings.ShowFilterRow = false;

        settings.SettingsPager.FirstPageButton.Visible = true;
        settings.SettingsPager.LastPageButton.Visible = true;
        settings.SettingsPager.ShowNumericButtons = true;
        settings.SettingsPager.Position = System.Web.UI.WebControls.PagerPosition.Bottom;
        settings.SettingsPager.PageSizeItemSettings.Visible = true;
        settings.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "25", "50", "100" };
        settings.SettingsPager.PageSize = 10;
        settings.SettingsPager.PageSizeItemSettings.Caption = "View per page";

        settings.Settings.VerticalScrollBarMode = ScrollBarMode.Auto;
        settings.Settings.HorizontalScrollBarMode = ScrollBarMode.Auto;
        settings.Settings.VerticalScrollableHeight = 250;

        settings.CustomJSProperties = (s, e) =>
        {

            MVCxGridView grid = (MVCxGridView)s;
            int startIndex = 0;
            int endIndex = 0;
            List<ServiceMappingMasterPrice> l = ViewData["ServicePriceGrid"] == null ? new List<ServiceMappingMasterPrice>() : (List<ServiceMappingMasterPrice>)ViewData["ServicePriceGrid"];
            endIndex = l.Count;

            object[] service_id = new object[endIndex - startIndex];
            object[] is_checked = new object[endIndex - startIndex];
            object[] is_checked_idx = new object[endIndex - startIndex];
            
            for (int n = startIndex; n < endIndex; n++)
            {
                service_id[n - startIndex] = grid.GetRowValues(n, "SERVICE_REGISTRATION");
                is_checked[n - startIndex] = grid.GetRowValues(n, "CHECKED_FLAG");
                is_checked_idx[n - startIndex] = false;
            }

            e.Properties["cpServiceId"] = service_id;
            e.Properties["cpIsChecked"] = is_checked;
            e.Properties["cpIsCheckedIdx"] = is_checked_idx;
            grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
            grid.JSProperties["cpStartIndex"] = startIndex;
            grid.JSProperties["cpEndIndex"] = endIndex;
        };
        // DXCOMMENT: Configure grid's columns in accordance with data model fields

        settings.CommandColumn.SetHeaderTemplateContent(c =>
        {
            if (c.Column.VisibleIndex == 0)
            {
                Html.DevExpress().CheckBox(
                    chckBox =>
                    {
                        chckBox.Name = "SMchckBox";
                        chckBox.Width = System.Web.UI.WebControls.Unit.Percentage(100);
                        //chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridServicePriceMaster.SelectAllRowsOnPage(SMchckBox.GetChecked());}";
                        chckBox.Properties.ClientSideEvents.CheckedChanged = "SelectAllCheckBox";
                    }
                ).Render();
            }
        }
        );

        settings.Columns.Add(
            column =>
            {
                column.FieldName = "SERVICE_REGISTRATION";
                column.Caption = "Service Registration";
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.Settings.AllowSort = DefaultBoolean.False;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.Width = Unit.Pixel(135);
            });
        settings.Columns.Add(
            column =>
            {
                column.FieldName = "SERVICE_CODE";
                column.Caption = "Service Code";
                column.CellStyle.Wrap = DefaultBoolean.True;
                column.Settings.AllowSort = DefaultBoolean.False;
                column.ColumnType = MVCxGridViewColumnType.TextBox;
                column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
                column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
                column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
                column.Width = Unit.Pixel(90);
            });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "SERVICE_NAME";
            column.Caption = "Service Name";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(150);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "SERVICE_TYPE";
            column.Caption = "Service Type";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(100);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "CONTAINER_SIZE";
            column.Caption = "Cont. Size";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(80);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "PRICE";
            column.Caption = "Price";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(150);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "CURRENCY";
            column.Caption = "Currency";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(70);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "VAT";
            column.Caption = "VAT";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(85);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "COST_CENTER";
            column.Caption = "Cost Center";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(85);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "VENDOR_TYPE";
            column.Caption = "Vendor Type";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.TextBox;
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(85);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "VALID_FROM";
            column.Caption = "Valid From";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.DateEdit;
            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(85);
        });
        settings.Columns.Add(
        column =>
        {
            column.FieldName = "VALID_TO";
            column.Caption = "Valid To";
            column.CellStyle.Wrap = DefaultBoolean.True;
            column.Settings.AllowSort = DefaultBoolean.False;
            column.ColumnType = MVCxGridViewColumnType.DateEdit;
            column.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
            column.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Left;
            column.CellStyle.VerticalAlign = System.Web.UI.WebControls.VerticalAlign.Middle;
            column.HeaderStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
            column.Width = Unit.Pixel(85);
        });
    }).Bind(ViewData["ServicePriceGrid"]).GetHtml()